diff a/test/hotspot/jtreg/premain/quarkus-getting-started/Makefile b/test/hotspot/jtreg/premain/quarkus-getting-started/Makefile
--- /dev/null
+++ b/test/hotspot/jtreg/premain/quarkus-getting-started/Makefile
@@ -0,0 +1,69 @@
+# Copyright (c) 2024, Oracle and/or its affiliates. All rights reserved.
+# DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+#
+# This code is free software; you can redistribute it and/or modify it
+# under the terms of the GNU General Public License version 2 only, as
+# published by the Free Software Foundation.
+#
+# This code is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+# version 2 for more details (a copy is included in the LICENSE file that
+# accompanied this code).
+#
+# You should have received a copy of the GNU General Public License version
+# 2 along with this work; if not, write to the Free Software Foundation,
+# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+#
+# Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+# or visit www.oracle.com if you need additional information or have any
+# questions.
+
+#===============================================================================
+# Leyden-premain + Quarkus getting-started demo
+#  - https://quarkus.io/guides/getting-started
+#  - https://quarkus.io/guides/lifecycle
+#
+# See ../lib/DemoSupport.gmk for the "make" targets that build the demo, run the
+# demo, and gather benchmarking data.
+#===============================================================================
+
+# The following needs to be defined before including ../lib/DemoSupport.gmk
+DEMO_NAME       = quarkus-getting-started
+DEMO_SRC        = getting-started/src/main/java/Main.java
+DEMO_JAR        = getting-started/target/getting-started-1.0.0-SNAPSHOT-runner.jar
+DEMO_CMDLINE    = -DautoQuit=true -Dquarkus.http.port=0 -jar ${DEMO_JAR}
+# This is for uploading into Artifactory, usually to a path like
+#    https://xxxx.com/artifactory/yyyy/io/quarkus/quarkus-getting-started/1.0.0b/quarkus-getting-started-1.0.0b.zip
+DEMO_ARTIFACT   = quarkus-getting-started-1.0.0b.zip
+
+include ../lib/DemoSupport.gmk
+
+# Create the project using instructions from https://quarkus.io/guides/getting-started, then
+# add the Main class which prints out the timing data and exits.
+${DEMO_SRC}: Main.java
+	rm -rf getting-started
+	JAVA_HOME=${BLDJDK_HOME} ${MVN} \
+	    io.quarkus.platform:quarkus-maven-plugin:3.9.3:create \
+	    -DprojectGroupId=org.acme \
+	    -DprojectArtifactId=getting-started \
+	    -Dextensions='rest'
+	cp Main.java ${DEMO_SRC}
+
+# We package the app in the "legacy-jar" to be CDS friendly
+# See https://quarkus.io/guides/class-loading-reference:
+#  "everything is loaded in the system ClassLoader, so it is a completely flat classpath."
+# See https://www.cheat-sheets.org/saved-copy/quarkus-cheat-sheet.pdf
+${DEMO_JAR}: ${DEMO_SRC}
+	cd getting-started && JAVA_HOME=${BLDJDK_HOME} ${MVN} -Dquarkus.package.type=legacy-jar install
+
+${DEMO_ARTIFACT}: ${DEMO_JAR}
+	${JAR} cvfM ${DEMO_ARTIFACT} \
+		-C getting-started/target .
+
+clean: clean0
+	rm -rf getting-started ${DEMO_ARTIFACT}
+
+clean0:
+	rm -f *.cds *.cds.code *.classlist *.jsa *~ *.log *.log.* hs_err_*
+
diff a/test/hotspot/jtreg/premain/simple/Makefile b/test/hotspot/jtreg/premain/simple/Makefile
--- /dev/null
+++ b/test/hotspot/jtreg/premain/simple/Makefile
@@ -0,0 +1,4 @@
+clean:
+	rm -f *.jsa *.jsa-sc *.log* *.classlist *~ Simple.jar tmpclasses
+
+
diff a/test/hotspot/jtreg/premain/simple/Simple.java b/test/hotspot/jtreg/premain/simple/Simple.java
--- /dev/null
+++ b/test/hotspot/jtreg/premain/simple/Simple.java
@@ -0,0 +1,49 @@
+public class Simple {
+    public static void main(String args[]) throws Exception {
+        if (args[0].equals("a")) {
+            foo("222");
+            System.out.print("OUTPUT = ");
+            System.out.println(x); // Avoid using + in diagnostic output.
+        } else if (args[0].equals("b")) {
+            bar("aaa", "222");
+            System.out.print("OUTPUT = ");
+            System.out.println(x); // Avoid using + in diagnostic output.
+        } else if (args[0].equals("c")) {
+            baz("aaa", 333);
+            System.out.print("OUTPUT = ");
+            System.out.println(x); // Avoid using + in diagnostic output.
+        } else if (args[0].equals("loopa")) {
+            loopa();
+            loopa();
+            System.out.print("OUTPUT = ");
+            System.out.println(x); // Avoid using + in diagnostic output.
+        }
+
+        if (args.length > 1 && args[1].equals("load-extra-class")) {
+            // Work around "There is no class to be included in the dynamic archive." problem, where the
+            // dynamic archive is not generated.
+            DummyClass.doit();
+        }
+    }
+
+    static void loopa() {
+        for (int i = 0; i < 100000; i++) {
+            foo("L");
+        }
+    }
+
+    static String x;
+    static void foo(String b) {
+        x = "LIT" + b;
+    }
+    static void bar(String a, String b) {
+        x = a + b;
+    }
+    static void baz(String a, int b) {
+        x = a + b;
+    }
+
+    static class DummyClass {
+        static void doit() {}
+    }
+}
diff a/test/hotspot/jtreg/premain/simple/run.sh b/test/hotspot/jtreg/premain/simple/run.sh
--- /dev/null
+++ b/test/hotspot/jtreg/premain/simple/run.sh
@@ -0,0 +1,42 @@
+# Copyright (c) 2023, Oracle and/or its affiliates. All rights reserved.
+# DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+#
+# This code is free software; you can redistribute it and/or modify it
+# under the terms of the GNU General Public License version 2 only, as
+# published by the Free Software Foundation.
+#
+# This code is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+# version 2 for more details (a copy is included in the LICENSE file that
+# accompanied this code).
+#
+# You should have received a copy of the GNU General Public License version
+# 2 along with this work; if not, write to the Free Software Foundation,
+# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+#
+# Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+# or visit www.oracle.com if you need additional information or have any
+# questions.
+
+# See ../lib/premain-run.sh for command-line options
+
+# simple/run.sh
+#
+#    Run a simple test case with a loop. Tests CDS handling of Lambda and AOT
+
+if test ! -f Simple.jar || test Simple.java -nt Simple.jar; then
+    rm -rf tmpclasses
+    mkdir -p tmpclasses
+    javac -d tmpclasses Simple.java || exit
+    jar cf Simple.jar -C tmpclasses . || exit
+    rm -rf tmpclasses
+fi
+
+JAVA=$1; shift 
+JAR=Simple.jar
+CMDLINE="-cp $JAR Simple loopa"
+APP=Simple
+
+source ../lib/premain-run.sh
+
diff a/test/hotspot/jtreg/premain/spring-boot-getting-started/Application.java b/test/hotspot/jtreg/premain/spring-boot-getting-started/Application.java
--- /dev/null
+++ b/test/hotspot/jtreg/premain/spring-boot-getting-started/Application.java
@@ -0,0 +1,73 @@
+/*
+ * Copyright (c) 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+
+package com.example.springboot;
+
+import java.util.Arrays;
+
+import java.lang.management.ManagementFactory;
+import java.lang.management.RuntimeMXBean;
+
+import org.springframework.boot.CommandLineRunner;
+import org.springframework.boot.SpringApplication;
+import org.springframework.boot.autoconfigure.SpringBootApplication;
+import org.springframework.context.ApplicationContext;
+import org.springframework.context.annotation.Bean;
+
+@SpringBootApplication
+public class Application {
+    static long mainStart, vmStart, maxBeanOverHead;
+
+    public static void main(String[] args) {
+ 	mainStart = System.currentTimeMillis();
+ 	RuntimeMXBean runtimeMXBean = ManagementFactory.getRuntimeMXBean();
+ 	// This includes all the time spent inside the JVM before main() is reached
+ 	// (since os::Posix::init is called and initial_time_count is initialized).
+ 	vmStart = runtimeMXBean.getStartTime();
+ 	maxBeanOverHead = System.currentTimeMillis() - mainStart;
+
+        SpringApplication.run(Application.class, args);
+    }
+
+    @Bean
+    public CommandLineRunner commandLineRunner(ApplicationContext ctx) {
+       if ("onRefresh".equals(System.getProperty("spring.context.exit"))) {
+            long end = System.currentTimeMillis();
+            System.out.println("#### Booted and returned in " + (end - vmStart - maxBeanOverHead) + "ms");
+            System.out.println("#### (debug) mainStart = " + mainStart);
+            System.out.println("#### (debug) vmStart = " + vmStart);
+            System.out.println("#### (debug) before main (mainStart - vmStart) = " + (mainStart - vmStart));
+            System.out.println("#### (debug) maxBeanOverHead = " + maxBeanOverHead);
+            System.out.println("#### (debug) end = " + end);
+       }
+
+       return args -> {
+           System.out.println("Let's inspect the beans provided by Spring Boot:");
+           String[] beanNames = ctx.getBeanDefinitionNames();
+           Arrays.sort(beanNames);
+           for (String beanName : beanNames) {
+               System.out.println(beanName);
+           }
+       };
+    }
+}
diff a/test/hotspot/jtreg/premain/spring-boot-getting-started/Makefile b/test/hotspot/jtreg/premain/spring-boot-getting-started/Makefile
--- /dev/null
+++ b/test/hotspot/jtreg/premain/spring-boot-getting-started/Makefile
@@ -0,0 +1,73 @@
+# Copyright (c) 2024, Oracle and/or its affiliates. All rights reserved.
+# DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+#
+# This code is free software; you can redistribute it and/or modify it
+# under the terms of the GNU General Public License version 2 only, as
+# published by the Free Software Foundation.
+#
+# This code is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+# version 2 for more details (a copy is included in the LICENSE file that
+# accompanied this code).
+#
+# You should have received a copy of the GNU General Public License version
+# 2 along with this work; if not, write to the Free Software Foundation,
+# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+#
+# Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+# or visit www.oracle.com if you need additional information or have any
+# questions.
+
+#===============================================================================
+# Leyden-premain + Sprint-boot getting-started demo
+#  - https://spring.io/guides/gs/spring-boot
+#  - https://docs.spring.io/spring-boot/maven-plugin/aot.html
+#  - https://bell-sw.com/blog/how-to-use-cds-with-spring-boot-applications/
+#
+# See ../lib/DemoSupport.gmk for the "make" targets that build the demo, run the
+# demo, and gather benchmarking data.
+#===============================================================================
+
+# The following needs to be defined before including ../lib/DemoSupport.gmk
+DEMO_NAME       = spring-boot-getting-started
+DEMO_SRC        = gs-spring-boot/complete/src/main/java/com/example/springboot/Application.java
+DEMO_JAR        = gs-spring-boot/complete/spring-boot-complete-0.0.1-SNAPSHOT/spring-boot-complete-0.0.1-SNAPSHOT.jar
+DEMO_CMDLINE    = -Dserver.port=0 -Dspring.aot.enabled=true -Dspring.output.ansi.enabled=NEVER -Dspring.context.exit=onRefresh -jar ${DEMO_JAR}
+# This is for uploading into Artifactory, usually to a path like
+#    https://xxxx.com/artifactory/yyyy/io/spring/spring-boot-getting-started/3.3.0/spring-boot-getting-started-3.3.0.zip
+DEMO_ARTIFACT   = spring-boot-getting-started-3.3.0.zip
+
+include ../lib/DemoSupport.gmk
+
+# Create the project using instructions from https://spring.io/guides/gs/spring-boot and
+# patch the ${DEMO_SRC} to show start-up measurement used by ../lib/DemoSupport.gmk
+# Note: we use GIT version 99085f078b01fed27667c0b8fbbb957758911f4a
+# Note: pom.xml is patched to add <goal>process-aot</goal>; see https://docs.spring.io/spring-boot/maven-plugin/aot.html
+${DEMO_SRC}: Application.java pom.xml
+	rm -rf gs-spring-boot ${DEMO_SRC}
+	git clone https://github.com/spring-guides/gs-spring-boot.git
+	cd gs-spring-boot; git reset --hard 99085f078b01fed27667c0b8fbbb957758911f4a
+	cp -v Application.java ${DEMO_SRC}
+	cp -v pom.xml gs-spring-boot/complete
+
+# Package the app in CDS friendly way
+# See https://bell-sw.com/blog/how-to-use-cds-with-spring-boot-applications/
+${DEMO_JAR}: ${DEMO_SRC}
+	cd gs-spring-boot/complete && JAVA_HOME=${BLDJDK_HOME} ${MVN} -Dmaven.test.skip=true package
+	cd gs-spring-boot/complete && ${BLDJDK_JAVA} -Djarmode=tools -jar target/spring-boot-complete-0.0.1-SNAPSHOT.jar extract
+
+${DEMO_ARTIFACT}: ${DEMO_JAR}
+	${JAR} cvfM ${DEMO_ARTIFACT} \
+		-C gs-spring-boot/complete/spring-boot-complete-0.0.1-SNAPSHOT .
+
+clean: clean0
+	rm -rf gs-spring-boot ${DEMO_ARTIFACT} mainline_vs_premain.* compare_premain_builds.*
+
+clean0:
+	rm -f *.cds *.cds.code *.classlist *.jsa *~ *.log *.log.* hs_err_* tmp.txt
+
+# Show the patch we made to gs-spring-boot
+diff:
+	cd gs-spring-boot; git diff -w
+
diff a/test/hotspot/jtreg/premain/spring-petclinic/.gitignore b/test/hotspot/jtreg/premain/spring-petclinic/.gitignore
--- /dev/null
+++ b/test/hotspot/jtreg/premain/spring-petclinic/.gitignore
@@ -0,0 +1,10 @@
+petclinic-snapshot
+*.cds
+*.cds.code
+*.jsa
+*.log
+*.log.*
+*.classlist
+*.preimage
+tmp.txt
+
diff a/test/hotspot/jtreg/premain/spring-petclinic/Dummy.java b/test/hotspot/jtreg/premain/spring-petclinic/Dummy.java
--- /dev/null
+++ b/test/hotspot/jtreg/premain/spring-petclinic/Dummy.java
@@ -0,0 +1,3 @@
+public class Dummy {
+    public static void main(String args[]) {}
+}
